> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Duplicate a campaign

> Creates a new draft campaign by deep-copying the supplied campaign version. The copy inherits all components, settings, and labels; the optional request body lets callers override the new campaign's name and label list. The new campaign is created in DRAFT state regardless of the source's state.



## OpenAPI

````yaml /api-reference/management.json post /v2/campaigns/{campaignId}{version}/duplicate
openapi: 3.0.1
info:
  description: >-
    Configuration endpoints for the Extole platform: campaigns, components,
    audiences, persons, rewards, reporting, integrations setup, and
    administrative tooling.
  title: Management API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Audiences
  - name: Authentication
  - name: Batch Jobs
  - name: Blocks
  - name: Campaigns
  - name: Components
  - name: Components Settings
  - name: Domains
  - name: Email
  - name: Erasure
  - name: Event Streams
  - name: File Validation Monitors
  - name: Optout
  - name: Profiles
  - name: Promotion Links
  - name: Report Schedules
  - name: Report Types
  - name: Reports
  - name: Reward Suppliers
  - name: Security Keys
  - name: Settings
  - name: User Notifications
  - name: User Subscriptions
  - name: Users
  - name: Webhooks
paths:
  /v2/campaigns/{campaignId}{version}/duplicate:
    post:
      tags:
        - Campaigns
      summary: Duplicate a campaign
      description: >-
        Creates a new draft campaign by deep-copying the supplied campaign
        version. The copy inherits all components, settings, and labels; the
        optional request body lets callers override the new campaign's name and
        label list. The new campaign is created in DRAFT state regardless of the
        source's state.
      operationId: duplicateCampaign
      parameters:
        - in: path
          name: campaignId
          required: true
          schema:
            type: string
        - in: path
          name: version
          required: true
          schema:
            pattern: (/version/.+)?
            type: string
      requestBody:
        content:
          application/json:
            example:
              description: description
              message: message
              name: name
              program_label: program_label
            schema:
              $ref: '#/components/schemas/CampaignDuplicateRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CampaignResponse'
          description: Duplicated campaign.
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                campaign_build_failed:
                  $ref: '#/components/examples/campaign_build_failed'
                campaign_component_absolute_name_missing:
                  $ref: >-
                    #/components/examples/campaign_component_absolute_name_missing
                campaign_component_description_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_description_out_of_range
                campaign_component_display_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_contains_illegal_character
                campaign_component_display_name_out_of_range:
                  $ref: >-
                    #/components/examples/campaign_component_display_name_out_of_range
                campaign_component_id_missing:
                  $ref: '#/components/examples/campaign_component_id_missing'
                campaign_component_name_already_in_use:
                  $ref: '#/components/examples/campaign_component_name_already_in_use'
                campaign_component_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_component_name_contains_illegal_character
                campaign_component_name_out_of_range:
                  $ref: '#/components/examples/campaign_component_name_out_of_range'
                campaign_component_not_found:
                  $ref: '#/components/examples/campaign_component_not_found'
                campaign_component_type_validation_failed:
                  $ref: >-
                    #/components/examples/campaign_component_type_validation_failed
                campaign_concurrent_update:
                  $ref: '#/components/examples/campaign_concurrent_update'
                campaign_controller_duplicate_controller:
                  $ref: >-
                    #/components/examples/campaign_controller_duplicate_controller
                campaign_controller_invalid_enabled_on_state:
                  $ref: >-
                    #/components/examples/campaign_controller_invalid_enabled_on_state
                campaign_controller_missing_event_trigger:
                  $ref: >-
                    #/components/examples/campaign_controller_missing_event_trigger
                campaign_controller_missing_journey_name:
                  $ref: >-
                    #/components/examples/campaign_controller_missing_journey_name
                campaign_controller_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_controller_name_contains_illegal_character
                campaign_controller_name_missing:
                  $ref: '#/components/examples/campaign_controller_name_missing'
                campaign_controller_name_out_of_range:
                  $ref: '#/components/examples/campaign_controller_name_out_of_range'
                campaign_controller_name_same_as_a_default_controller_name:
                  $ref: >-
                    #/components/examples/campaign_controller_name_same_as_a_default_controller_name
                campaign_controller_too_many_journey_names:
                  $ref: >-
                    #/components/examples/campaign_controller_too_many_journey_names
                campaign_has_pending_changes:
                  $ref: '#/components/examples/campaign_has_pending_changes'
                campaign_invalid_tag:
                  $ref: '#/components/examples/campaign_invalid_tag'
                campaign_locked:
                  $ref: '#/components/examples/campaign_locked'
                campaign_tags_too_long:
                  $ref: '#/components/examples/campaign_tags_too_long'
                campaign_version_malformed:
                  $ref: '#/components/examples/campaign_version_malformed'
                circular_component_reference:
                  $ref: '#/components/examples/circular_component_reference'
                component_facets_not_found:
                  $ref: '#/components/examples/component_facets_not_found'
                component_id_not_accessible:
                  $ref: '#/components/examples/component_id_not_accessible'
                controller_state_misconfiguration:
                  $ref: '#/components/examples/controller_state_misconfiguration'
                date_invalid:
                  $ref: '#/components/examples/date_invalid'
                default_key_not_allowed:
                  $ref: '#/components/examples/default_key_not_allowed'
                display_name_has_illegal_character:
                  $ref: '#/components/examples/display_name_has_illegal_character'
                duplicate_step_data_name:
                  $ref: '#/components/examples/duplicate_step_data_name'
                excessive_component_reference:
                  $ref: '#/components/examples/excessive_component_reference'
                expression_invalid_syntax:
                  $ref: '#/components/examples/expression_invalid_syntax'
                external_element_is_referenced_by_active_configuration:
                  $ref: >-
                    #/components/examples/external_element_is_referenced_by_active_configuration
                external_elements_cannot_have_multiple_references:
                  $ref: >-
                    #/components/examples/external_elements_cannot_have_multiple_references
                invalid_campaign_id:
                  $ref: '#/components/examples/invalid_campaign_id'
                invalid_campaign_state:
                  $ref: '#/components/examples/invalid_campaign_state'
                invalid_campaign_version:
                  $ref: '#/components/examples/invalid_campaign_version'
                invalid_component_installed_into_socket:
                  $ref: >-
                    #/components/examples/invalid_component_installed_into_socket
                invalid_component_reference:
                  $ref: '#/components/examples/invalid_component_reference'
                invalid_component_reference_socket_name:
                  $ref: >-
                    #/components/examples/invalid_component_reference_socket_name
                invalid_external_component_reference:
                  $ref: '#/components/examples/invalid_external_component_reference'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                invalid_program_type:
                  $ref: '#/components/examples/invalid_program_type'
                invalid_step_alias:
                  $ref: '#/components/examples/invalid_step_alias'
                invalid_theme_name:
                  $ref: '#/components/examples/invalid_theme_name'
                invalid_translatable_value:
                  $ref: '#/components/examples/invalid_translatable_value'
                lock_missing_lock_types:
                  $ref: '#/components/examples/lock_missing_lock_types'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                missing_step_data_name:
                  $ref: '#/components/examples/missing_step_data_name'
                missing_step_data_value:
                  $ref: '#/components/examples/missing_step_data_value'
                multiple_components_installed_into_single_socket:
                  $ref: >-
                    #/components/examples/multiple_components_installed_into_single_socket
                non_translatable_variable_can_not_be_updated:
                  $ref: >-
                    #/components/examples/non_translatable_variable_can_not_be_updated
                orphan_external_component_reference:
                  $ref: '#/components/examples/orphan_external_component_reference'
                program_type_empty:
                  $ref: '#/components/examples/program_type_empty'
                rebuild_campaigns_build_failed:
                  $ref: '#/components/examples/rebuild_campaigns_build_failed'
                redundant_component_reference:
                  $ref: '#/components/examples/redundant_component_reference'
                reward_supplier_id_list_invalid_configuration:
                  $ref: >-
                    #/components/examples/reward_supplier_id_list_invalid_configuration
                self_component_reference:
                  $ref: '#/components/examples/self_component_reference'
                setting_batch_update_missing_request:
                  $ref: '#/components/examples/setting_batch_update_missing_request'
                setting_display_name_length_out_of_range:
                  $ref: >-
                    #/components/examples/setting_display_name_length_out_of_range
                setting_filter_component_facet_name_missing:
                  $ref: >-
                    #/components/examples/setting_filter_component_facet_name_missing
                setting_filter_component_facet_value_missing:
                  $ref: >-
                    #/components/examples/setting_filter_component_facet_value_missing
                setting_filter_component_type_missing:
                  $ref: '#/components/examples/setting_filter_component_type_missing'
                setting_filter_expression_evaluation_failed:
                  $ref: >-
                    #/components/examples/setting_filter_expression_evaluation_failed
                setting_filter_invalid_component_facet:
                  $ref: '#/components/examples/setting_filter_invalid_component_facet'
                setting_filter_invalid_component_type:
                  $ref: '#/components/examples/setting_filter_invalid_component_type'
                setting_name_duplicated:
                  $ref: '#/components/examples/setting_name_duplicated'
                setting_name_length_out_of_range:
                  $ref: '#/components/examples/setting_name_length_out_of_range'
                setting_name_missing:
                  $ref: '#/components/examples/setting_name_missing'
                setting_name_reserved:
                  $ref: '#/components/examples/setting_name_reserved'
                setting_validation_exception:
                  $ref: '#/components/examples/setting_validation_exception'
                settings_build_failed:
                  $ref: '#/components/examples/settings_build_failed'
                socket_missing_required_parameter:
                  $ref: '#/components/examples/socket_missing_required_parameter'
                step_data_default_value_expression_length_out_of_range:
                  $ref: >-
                    #/components/examples/step_data_default_value_expression_length_out_of_range
                step_data_name_length_out_of_range:
                  $ref: '#/components/examples/step_data_name_length_out_of_range'
                step_data_value_expression_length_out_of_range:
                  $ref: >-
                    #/components/examples/step_data_value_expression_length_out_of_range
                tag_length_out_of_range:
                  $ref: '#/components/examples/tag_length_out_of_range'
                unavailable_referenced_variable:
                  $ref: '#/components/examples/unavailable_referenced_variable'
                unlock_missing_lock_types:
                  $ref: '#/components/examples/unlock_missing_lock_types'
                variable_circular_reference:
                  $ref: '#/components/examples/variable_circular_reference'
                variable_description_length_out_of_range:
                  $ref: >-
                    #/components/examples/variable_description_length_out_of_range
                variable_value_invalid_type:
                  $ref: '#/components/examples/variable_value_invalid_type'
                variable_value_key_length_out_of_range:
                  $ref: '#/components/examples/variable_value_key_length_out_of_range'
                variable_value_missing:
                  $ref: '#/components/examples/variable_value_missing'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                campaign_description_out_of_range:
                  $ref: '#/components/examples/campaign_description_out_of_range'
                campaign_label_name_already_in_use:
                  $ref: '#/components/examples/campaign_label_name_already_in_use'
                campaign_label_name_contains_illegal_character:
                  $ref: >-
                    #/components/examples/campaign_label_name_contains_illegal_character
                campaign_label_name_missing:
                  $ref: '#/components/examples/campaign_label_name_missing'
                campaign_label_name_out_of_range:
                  $ref: '#/components/examples/campaign_label_name_out_of_range'
                campaign_name_already_used:
                  $ref: '#/components/examples/campaign_name_already_used'
                campaign_name_illegal_character:
                  $ref: '#/components/examples/campaign_name_illegal_character'
                campaign_name_is_missing:
                  $ref: '#/components/examples/campaign_name_is_missing'
                campaign_name_out_of_range:
                  $ref: '#/components/examples/campaign_name_out_of_range'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '404':
          content:
            application/json:
              examples:
                campaign_not_found:
                  $ref: '#/components/examples/campaign_not_found'
          description: >-
            Campaign was not found. The supplied id does not match any campaign
            accessible to the calling client.
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    CampaignDuplicateRequest:
      properties:
        description:
          nullable: true
          type: string
        message:
          nullable: true
          type: string
        name:
          nullable: true
          type: string
        program_label:
          nullable: true
          type: string
      required:
        - description
        - message
        - name
        - program_label
      type: object
    CampaignResponse:
      description: >-
        Stored campaign definition. Fields `variant_selector` and `variants` are
        unevaluated and appear in buildtime-evaluatable form.
      properties:
        campaign_id:
          type: string
        campaign_locks:
          items:
            enum:
              - DUPLICATE
              - EDIT
            type: string
          type: array
          uniqueItems: true
        campaign_type:
          enum:
            - CONFIGURATION
            - EXTENSION
            - INTEGRATION
            - MARKETING
          type: string
        components:
          items:
            $ref: '#/components/schemas/CampaignComponentResponse'
          type: array
        description:
          type: string
        end_date:
          $ref: '#/components/schemas/ZonedDateTime'
        flow_steps:
          items:
            $ref: '#/components/schemas/CampaignFlowStepResponse'
          type: array
        incentive:
          $ref: '#/components/schemas/IncentiveResponse'
        incentive_id:
          type: string
        is_published:
          type: boolean
        labels:
          items:
            $ref: '#/components/schemas/CampaignLabelResponse'
          type: array
        last_published_date:
          $ref: '#/components/schemas/ZonedDateTime'
        name:
          type: string
        parent_version:
          format: int32
          nullable: true
          type: integer
        pause_date:
          $ref: '#/components/schemas/ZonedDateTime'
        program_label:
          type: string
        program_type:
          type: string
        start_date:
          $ref: '#/components/schemas/ZonedDateTime'
        state:
          enum:
            - ARCHIVED
            - ENDED
            - LIVE
            - NOT_LAUNCHED
            - PAUSED
            - STOPPED
          type: string
        steps:
          items:
            $ref: '#/components/schemas/CampaignStepResponse'
          type: array
        stop_date:
          $ref: '#/components/schemas/ZonedDateTime'
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        theme_name:
          type: string
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
        variant_selector:
          $ref: '#/components/schemas/VariantSelectorInCampaignResponse'
        variants:
          $ref: '#/components/schemas/VariantsInCampaignResponse'
        version:
          format: int32
          type: integer
      required:
        - campaign_id
        - campaign_locks
        - campaign_type
        - components
        - description
        - end_date
        - flow_steps
        - incentive
        - incentive_id
        - is_published
        - labels
        - last_published_date
        - name
        - parent_version
        - pause_date
        - program_label
        - program_type
        - start_date
        - state
        - steps
        - stop_date
        - tags
        - theme_name
        - updated_date
        - variant_selector
        - variants
        - version
      type: object
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    CampaignComponentResponse:
      description: >-
        Stored campaign component definition. Field `display_name` is
        unevaluated and appears in buildtime-evaluatable form.
      properties:
        assets:
          items:
            $ref: '#/components/schemas/ComponentAssetResponse'
          type: array
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        created_date:
          $ref: '#/components/schemas/ZonedDateTime'
        description:
          type: string
        display_name:
          $ref: '#/components/schemas/DisplayNameInCampaignComponentResponse'
        facets:
          items:
            $ref: '#/components/schemas/CampaignComponentFacetResponse'
          type: array
        id:
          readOnly: true
          type: string
        install:
          $ref: '#/components/schemas/InstallInCampaignComponentResponse'
        installed_into_socket:
          type: string
        name:
          type: string
        origin:
          $ref: '#/components/schemas/ComponentOriginResponse'
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
        type:
          type: string
        types:
          items:
            type: string
          type: array
        updated_date:
          $ref: '#/components/schemas/ZonedDateTime'
        upload_version:
          type: string
        variables:
          items:
            $ref: '#/components/schemas/CampaignComponentSettingResponse'
          type: array
        version:
          format: int32
          type: integer
      required:
        - assets
        - component_ids
        - component_references
        - created_date
        - description
        - display_name
        - facets
        - id
        - install
        - installed_into_socket
        - name
        - origin
        - tags
        - type
        - types
        - updated_date
        - upload_version
        - variables
        - version
      type: object
    ZonedDateTime:
      description: >-
        [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) or
        [RFC 9557](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        date-time with a numeric [UTC
        offset](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) and
        an optional [IANA
        time-zone](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        suffix in square brackets. Precision up to milliseconds.
      example: '2025-10-24T02:00:00-07:00'
      pattern: >-
        ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?(Z|[+-](?:[01][0-9]|2[0-3]):[0-5][0-9])(\[[^\]]+\])?$
      type: string
    CampaignFlowStepResponse:
      description: >-
        Stored campaign flow step definition. Fields `flow_path`, `sequence`,
        `step_name`, `icon_type`, `tags`, `name`, `icon_color`, and
        `description` are unevaluated and appear in buildtime-evaluatable form.
      properties:
        apps:
          items:
            $ref: '#/components/schemas/CampaignFlowStepAppResponse'
          type: array
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          $ref: '#/components/schemas/DescriptionInCampaignFlowStepResponse'
        flow_path:
          $ref: '#/components/schemas/FlowPathInCampaignFlowStepResponse'
        flow_step_id:
          type: string
        icon_color:
          $ref: '#/components/schemas/IconColorInCampaignFlowStepResponse'
        icon_type:
          $ref: '#/components/schemas/IconTypeInCampaignFlowStepResponse'
        metrics:
          items:
            $ref: '#/components/schemas/CampaignFlowStepMetricResponse'
          type: array
        name:
          $ref: '#/components/schemas/NameInCampaignFlowStepResponse'
        sequence:
          $ref: '#/components/schemas/SequenceInCampaignFlowStepResponse'
        step_name:
          $ref: '#/components/schemas/StepNameInCampaignFlowStepResponse'
        tags:
          $ref: '#/components/schemas/TagsInCampaignFlowStepResponse'
        words:
          $ref: '#/components/schemas/CampaignFlowStepWordsResponse'
      required:
        - apps
        - component_ids
        - component_references
        - description
        - flow_path
        - flow_step_id
        - icon_color
        - icon_type
        - metrics
        - name
        - sequence
        - step_name
        - tags
        - words
      type: object
    IncentiveResponse:
      properties:
        id:
          readOnly: true
          type: string
        quality_rules:
          items:
            $ref: '#/components/schemas/QualityRuleResponse'
          type: array
        reward_rules:
          items:
            $ref: '#/components/schemas/RewardRuleResponse'
          type: array
        transition_rules:
          items:
            $ref: '#/components/schemas/TransitionRuleResponse'
          type: array
      required:
        - id
        - quality_rules
        - reward_rules
        - transition_rules
      type: object
    CampaignLabelResponse:
      properties:
        name:
          type: string
        type:
          enum:
            - DATA
            - PROGRAM
          type: string
      type: object
    CampaignStepResponse:
      discriminator:
        mapping:
          CONTROLLER:
            $ref: '#/components/schemas/CampaignControllerResponse'
          FRONTEND_CONTROLLER:
            $ref: '#/components/schemas/CampaignFrontendControllerResponse'
          JOURNEY_ENTRY:
            $ref: '#/components/schemas/CampaignJourneyEntryResponse'
        propertyName: type
      oneOf:
        - title: CONTROLLER
          allOf:
            - $ref: '#/components/schemas/CampaignControllerResponse'
        - title: FRONTEND_CONTROLLER
          allOf:
            - $ref: '#/components/schemas/CampaignFrontendControllerResponse'
        - title: JOURNEY_ENTRY
          allOf:
            - $ref: '#/components/schemas/CampaignJourneyEntryResponse'
      required:
        - component_ids
        - component_references
        - created_date
        - data
        - enabled
        - id
        - step_builder
        - triggers
        - type
        - updated_date
    VariantSelectorInCampaignResponse:
      description: >-
        The variant selector as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
                  - pattern: ^handlebars@runtime:.*
                    type: string
                  - pattern: ^javascript@runtime:.*
                    type: string
              type: string
          description: Literal variant selector
          title: Static Value
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{variantSelector}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('variantSelector');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
        - description: >-
            Handlebars expression with
            [VariantSelectionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts).
          example: handlebars@runtime:{{variantSelector}}
          externalDocs:
            description: VariantSelectionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [VariantSelectionContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('variantSelector');}
          externalDocs:
            description: VariantSelectionContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/VariantSelectionContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    VariantsInCampaignResponse:
      description: >-
        The variants as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal variants
          items:
            type: string
          title: Static Value
          type: array
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{variants}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('variants');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    ComponentAssetResponse:
      properties:
        description:
          type: string
        filename:
          type: string
        id:
          type: string
        name:
          type: string
        tags:
          items:
            type: string
          type: array
          uniqueItems: true
      type: object
    ComponentReferenceResponse:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
    DisplayNameInCampaignComponentResponse:
      description: >-
        The display name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal display name
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{displayName}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('displayName');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    CampaignComponentFacetResponse:
      properties:
        name:
          type: string
        value:
          type: string
      type: object
    InstallInCampaignComponentResponse:
      description: >-
        The install as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal install
          title: Static Value
          type: object
        - description: >-
            Handlebars expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: handlebars@installtime:{{install}}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^handlebars@installtime:.*
          title: Installtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ComponentInstalltimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts).
          example: >-
            javascript@installtime:function() { return
            context.getVariableContext().get('install');}
          externalDocs:
            description: ComponentInstalltimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/component/install/ComponentInstalltimeContext.d.ts
          pattern: ^javascript@installtime:.*
          title: Installtime - Javascript
          type: string
    ComponentOriginResponse:
      properties:
        client_id:
          type: string
        component_id:
          type: string
        component_version:
          format: int32
          type: integer
      type: object
    CampaignComponentSettingResponse:
      discriminator:
        mapping:
          ADMIN_ICON:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsAdminIcon'
          AUDIENCE_ID:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsAudienceId'
          AUDIENCE_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsAudienceIdList
          BOOLEAN:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsBoolean'
          BROWSER_SIDE_JAVASCRIPT:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsBrowserSideJavascript
          CLIENT_DOMAIN_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsClientDomainIdList
          CLIENT_KEY:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsClientKey'
          CLIENT_KEY_FLOW:
            $ref: >-
              #/components/schemas/CampaignComponentClientKeyFlowVariableResponse
          COLOR:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsColor'
          COMPONENT_ID:
            $ref: '#/components/schemas/CampaignComponentComponentIdVariableResponse'
          COMPONENT_SETTING_LOOKUP:
            $ref: >-
              #/components/schemas/CampaignComponentComponentSettingLookupVariableResponse
          CSS:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsCss'
          DELAY:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelay'
          DELAY_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelayList'
          ENUM:
            $ref: '#/components/schemas/CampaignComponentEnumVariableResponse'
          ENUM_LIST:
            $ref: '#/components/schemas/CampaignComponentEnumListVariableResponse'
          EXTOLE_CLIENT_KEY:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsExtoleClientKey
          FONT:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsFont'
          GLOB_COMPONENT_PATH:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsGlobComponentPath
          HTML:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsHtml'
          IMAGE:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsImage'
          INTEGER:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsInteger'
          INTEGER_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsIntegerList
          JSON:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsJson'
          MULTI_SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketResponseAsMultiSocket'
          PARTNER_ENUM:
            $ref: '#/components/schemas/CampaignComponentPartnerEnumVariableResponse'
          PARTNER_ENUM_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentPartnerEnumListVariableResponse
          PERSON_KEY_NAME:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsPersonKeyName
          REWARD_SUPPLIER_ID:
            $ref: >-
              #/components/schemas/CampaignComponentVariableResponseAsRewardSupplierId
          REWARD_SUPPLIER_ID_LIST:
            $ref: >-
              #/components/schemas/CampaignComponentRewardSupplierIdListVariableResponse
          SOCKET:
            $ref: '#/components/schemas/CampaignComponentSocketResponseAsSocket'
          STRING:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsString'
          STRING_LIST:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsStringList'
          STRING_MAP:
            $ref: '#/components/schemas/CampaignComponentStringMapVariableResponse'
          URL:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsUrl'
          WEBHOOK_ID:
            $ref: '#/components/schemas/CampaignComponentVariableResponseAsWebhookId'
        propertyName: type
      oneOf:
        - title: ADMIN_ICON
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAdminIcon
        - title: AUDIENCE_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAudienceId
        - title: AUDIENCE_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsAudienceIdList
        - title: BOOLEAN
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsBoolean'
        - title: BROWSER_SIDE_JAVASCRIPT
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsBrowserSideJavascript
        - title: CLIENT_DOMAIN_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsClientDomainIdList
        - title: CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsClientKey
        - title: CLIENT_KEY_FLOW
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentClientKeyFlowVariableResponse
        - title: COLOR
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsColor'
        - title: COMPONENT_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentComponentIdVariableResponse
        - title: COMPONENT_SETTING_LOOKUP
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentComponentSettingLookupVariableResponse
        - title: CSS
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsCss'
        - title: DELAY
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsDelay'
        - title: DELAY_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsDelayList
        - title: ENUM
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumVariableResponse'
        - title: ENUM_LIST
          allOf:
            - $ref: '#/components/schemas/CampaignComponentEnumListVariableResponse'
        - title: EXTOLE_CLIENT_KEY
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsExtoleClientKey
        - title: FONT
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsFont'
        - title: GLOB_COMPONENT_PATH
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsGlobComponentPath
        - title: HTML
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsHtml'
        - title: IMAGE
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsImage'
        - title: INTEGER
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsInteger'
        - title: INTEGER_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsIntegerList
        - title: JSON
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsJson'
        - title: MULTI_SOCKET
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentSocketResponseAsMultiSocket
        - title: PARTNER_ENUM
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentPartnerEnumVariableResponse
        - title: PARTNER_ENUM_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentPartnerEnumListVariableResponse
        - title: PERSON_KEY_NAME
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsPersonKeyName
        - title: REWARD_SUPPLIER_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsRewardSupplierId
        - title: REWARD_SUPPLIER_ID_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentRewardSupplierIdListVariableResponse
        - title: SOCKET
          allOf:
            - $ref: '#/components/schemas/CampaignComponentSocketResponseAsSocket'
        - title: STRING
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsString'
        - title: STRING_LIST
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsStringList
        - title: STRING_MAP
          allOf:
            - $ref: '#/components/schemas/CampaignComponentStringMapVariableResponse'
        - title: URL
          allOf:
            - $ref: '#/components/schemas/CampaignComponentVariableResponseAsUrl'
        - title: WEBHOOK_ID
          allOf:
            - $ref: >-
                #/components/schemas/CampaignComponentVariableResponseAsWebhookId
      required:
        - description
        - display_name
        - name
        - priority
        - tags
        - type
    CampaignFlowStepAppResponse:
      description: >-
        Stored campaign flow step app definition. Fields `name` and
        `description` are unevaluated and appear in buildtime-evaluatable form.
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          $ref: '#/components/schemas/DescriptionInCampaignFlowStepAppResponse'
        id:
          readOnly: true
          type: string
        name:
          $ref: '#/components/schemas/NameInCampaignFlowStepAppResponse'
        type:
          $ref: '#/components/schemas/CampaignFlowStepAppTypeResponse'
      required:
        - component_ids
        - component_references
        - description
        - id
        - name
        - type
      type: object
    DescriptionInCampaignFlowStepResponse:
      description: >-
        The description as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal description
          nullable: true
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{description}}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('description');}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    FlowPathInCampaignFlowStepResponse:
      description: >-
        The flow path as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal flow path
          title: Static Value
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{flowPath}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('flowPath');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    IconColorInCampaignFlowStepResponse:
      description: >-
        The icon color as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal icon color
          title: Static Value
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{iconColor}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('iconColor');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    IconTypeInCampaignFlowStepResponse:
      description: >-
        The icon type as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal icon type
          title: Static Value
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{iconType}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('iconType');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    CampaignFlowStepMetricResponse:
      description: >-
        Stored campaign flow step metric definition. Fields `name`,
        `description`, `expression`, `unit`, and `tags` are unevaluated and
        appear in buildtime-evaluatable form.
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        description:
          $ref: '#/components/schemas/DescriptionInCampaignFlowStepMetricResponse'
        expression:
          $ref: '#/components/schemas/ExpressionInCampaignFlowStepMetricResponse'
        id:
          readOnly: true
          type: string
        name:
          $ref: '#/components/schemas/NameInCampaignFlowStepMetricResponse'
        tags:
          $ref: '#/components/schemas/TagsInCampaignFlowStepMetricResponse'
        unit:
          $ref: '#/components/schemas/UnitInCampaignFlowStepMetricResponse'
      required:
        - component_ids
        - component_references
        - description
        - expression
        - id
        - name
        - tags
        - unit
      type: object
    NameInCampaignFlowStepResponse:
      description: >-
        The name as configured: a literal value, or an expression (type:string)
        when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal name
          title: Static Value
        - description: >-
            Handlebars expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{name}}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('name');}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    SequenceInCampaignFlowStepResponse:
      description: >-
        The sequence as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal sequence
          title: Static Value
          type: number
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{sequence}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('sequence');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    StepNameInCampaignFlowStepResponse:
      description: >-
        The step name as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - allOf:
            - type: string
            - not:
                anyOf:
                  - pattern: ^handlebars@buildtime:.*
                    type: string
                  - pattern: ^javascript@buildtime:.*
                    type: string
              type: string
          description: Literal step name
          title: Static Value
        - description: >-
            Handlebars expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{stepName}}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [CampaignBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('stepName');}
          externalDocs:
            description: CampaignBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/CampaignBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    TagsInCampaignFlowStepResponse:
      description: >-
        The tags as configured: a literal value, or an expression (type:string)
        when defined dynamically.
      oneOf:
        - description: Literal tags
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: handlebars@buildtime:{{tags}}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^handlebars@buildtime:.*
          title: Buildtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [AllFlowStepsBuildtimeContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts).
          example: >-
            javascript@buildtime:function() { return
            context.getVariableContext().get('tags');}
          externalDocs:
            description: AllFlowStepsBuildtimeContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/campaign/AllFlowStepsBuildtimeContext.d.ts
          pattern: ^javascript@buildtime:.*
          title: Buildtime - Javascript
          type: string
    CampaignFlowStepWordsResponse:
      properties:
        person_counting_name:
          $ref: >-
            #/components/schemas/PersonCountingNameInCampaignFlowStepWordsResponse
        plural_noun_name:
          $ref: '#/components/schemas/PluralNounNameInCampaignFlowStepWordsResponse'
        rate_name:
          $ref: '#/components/schemas/RateNameInCampaignFlowStepWordsResponse'
        singular_noun_name:
          $ref: '#/components/schemas/SingularNounNameInCampaignFlowStepWordsResponse'
        verb_name:
          $ref: '#/components/schemas/VerbNameInCampaignFlowStepWordsResponse'
      type: object
    QualityRuleResponse:
      properties:
        action_types:
          items:
            enum:
              - ANY_CLICK
              - ANY_PROMOTION
              - ANY_PURCHASE
              - ANY_REGISTER
              - ANY_SHARE
              - ANY_SHARE_REWARD
              - GENERIC_ACTION_1
              - GENERIC_ACTION_10
              - GENERIC_ACTION_100
              - GENERIC_ACTION_101
              - GENERIC_ACTION_102
              - GENERIC_ACTION_103
              - GENERIC_ACTION_104
              - GENERIC_ACTION_105
              - GENERIC_ACTION_106
              - GENERIC_ACTION_107
              - GENERIC_ACTION_108
              - GENERIC_ACTION_109
              - GENERIC_ACTION_11
              - GENERIC_ACTION_110
              - GENERIC_ACTION_111
              - GENERIC_ACTION_112
              - GENERIC_ACTION_113
              - GENERIC_ACTION_114
              - GENERIC_ACTION_115
              - GENERIC_ACTION_116
              - GENERIC_ACTION_117
              - GENERIC_ACTION_118
              - GENERIC_ACTION_119
              - GENERIC_ACTION_12
              - GENERIC_ACTION_120
              - GENERIC_ACTION_121
              - GENERIC_ACTION_122
              - GENERIC_ACTION_123
              - GENERIC_ACTION_124
              - GENERIC_ACTION_125
              - GENERIC_ACTION_126
              - GENERIC_ACTION_127
              - GENERIC_ACTION_128
              - GENERIC_ACTION_129
              - GENERIC_ACTION_13
              - GENERIC_ACTION_130
              - GENERIC_ACTION_131
              - GENERIC_ACTION_132
              - GENERIC_ACTION_133
              - GENERIC_ACTION_134
              - GENERIC_ACTION_135
              - GENERIC_ACTION_136
              - GENERIC_ACTION_137
              - GENERIC_ACTION_138
              - GENERIC_ACTION_139
              - GENERIC_ACTION_14
              - GENERIC_ACTION_140
              - GENERIC_ACTION_141
              - GENERIC_ACTION_142
              - GENERIC_ACTION_143
              - GENERIC_ACTION_144
              - GENERIC_ACTION_145
              - GENERIC_ACTION_146
              - GENERIC_ACTION_147
              - GENERIC_ACTION_148
              - GENERIC_ACTION_149
              - GENERIC_ACTION_15
              - GENERIC_ACTION_150
              - GENERIC_ACTION_151
              - GENERIC_ACTION_152
              - GENERIC_ACTION_153
              - GENERIC_ACTION_154
              - GENERIC_ACTION_155
              - GENERIC_ACTION_156
              - GENERIC_ACTION_157
              - GENERIC_ACTION_158
              - GENERIC_ACTION_159
              - GENERIC_ACTION_16
              - GENERIC_ACTION_160
              - GENERIC_ACTION_161
              - GENERIC_ACTION_162
              - GENERIC_ACTION_163
              - GENERIC_ACTION_164
              - GENERIC_ACTION_165
              - GENERIC_ACTION_166
              - GENERIC_ACTION_167
              - GENERIC_ACTION_168
              - GENERIC_ACTION_169
              - GENERIC_ACTION_17
              - GENERIC_ACTION_170
              - GENERIC_ACTION_171
              - GENERIC_ACTION_172
              - GENERIC_ACTION_173
              - GENERIC_ACTION_174
              - GENERIC_ACTION_175
              - GENERIC_ACTION_176
              - GENERIC_ACTION_177
              - GENERIC_ACTION_178
              - GENERIC_ACTION_179
              - GENERIC_ACTION_18
              - GENERIC_ACTION_180
              - GENERIC_ACTION_181
              - GENERIC_ACTION_182
              - GENERIC_ACTION_183
              - GENERIC_ACTION_184
              - GENERIC_ACTION_185
              - GENERIC_ACTION_186
              - GENERIC_ACTION_187
              - GENERIC_ACTION_188
              - GENERIC_ACTION_189
              - GENERIC_ACTION_19
              - GENERIC_ACTION_190
              - GENERIC_ACTION_191
              - GENERIC_ACTION_192
              - GENERIC_ACTION_193
              - GENERIC_ACTION_194
              - GENERIC_ACTION_195
              - GENERIC_ACTION_196
              - GENERIC_ACTION_197
              - GENERIC_ACTION_198
              - GENERIC_ACTION_199
              - GENERIC_ACTION_2
              - GENERIC_ACTION_20
              - GENERIC_ACTION_200
              - GENERIC_ACTION_21
              - GENERIC_ACTION_22
              - GENERIC_ACTION_23
              - GENERIC_ACTION_24
              - GENERIC_ACTION_25
              - GENERIC_ACTION_26
              - GENERIC_ACTION_27
              - GENERIC_ACTION_28
              - GENERIC_ACTION_29
              - GENERIC_ACTION_3
              - GENERIC_ACTION_30
              - GENERIC_ACTION_31
              - GENERIC_ACTION_32
              - GENERIC_ACTION_33
              - GENERIC_ACTION_34
              - GENERIC_ACTION_35
              - GENERIC_ACTION_36
              - GENERIC_ACTION_37
              - GENERIC_ACTION_38
              - GENERIC_ACTION_39
              - GENERIC_ACTION_4
              - GENERIC_ACTION_40
              - GENERIC_ACTION_41
              - GENERIC_ACTION_42
              - GENERIC_ACTION_43
              - GENERIC_ACTION_44
              - GENERIC_ACTION_45
              - GENERIC_ACTION_46
              - GENERIC_ACTION_47
              - GENERIC_ACTION_48
              - GENERIC_ACTION_49
              - GENERIC_ACTION_5
              - GENERIC_ACTION_50
              - GENERIC_ACTION_51
              - GENERIC_ACTION_52
              - GENERIC_ACTION_53
              - GENERIC_ACTION_54
              - GENERIC_ACTION_55
              - GENERIC_ACTION_56
              - GENERIC_ACTION_57
              - GENERIC_ACTION_58
              - GENERIC_ACTION_59
              - GENERIC_ACTION_6
              - GENERIC_ACTION_60
              - GENERIC_ACTION_61
              - GENERIC_ACTION_62
              - GENERIC_ACTION_63
              - GENERIC_ACTION_64
              - GENERIC_ACTION_65
              - GENERIC_ACTION_66
              - GENERIC_ACTION_67
              - GENERIC_ACTION_68
              - GENERIC_ACTION_69
              - GENERIC_ACTION_7
              - GENERIC_ACTION_70
              - GENERIC_ACTION_71
              - GENERIC_ACTION_72
              - GENERIC_ACTION_73
              - GENERIC_ACTION_74
              - GENERIC_ACTION_75
              - GENERIC_ACTION_76
              - GENERIC_ACTION_77
              - GENERIC_ACTION_78
              - GENERIC_ACTION_79
              - GENERIC_ACTION_8
              - GENERIC_ACTION_80
              - GENERIC_ACTION_81
              - GENERIC_ACTION_82
              - GENERIC_ACTION_83
              - GENERIC_ACTION_84
              - GENERIC_ACTION_85
              - GENERIC_ACTION_86
              - GENERIC_ACTION_87
              - GENERIC_ACTION_88
              - GENERIC_ACTION_89
              - GENERIC_ACTION_9
              - GENERIC_ACTION_90
              - GENERIC_ACTION_91
              - GENERIC_ACTION_92
              - GENERIC_ACTION_93
              - GENERIC_ACTION_94
              - GENERIC_ACTION_95
              - GENERIC_ACTION_96
              - GENERIC_ACTION_97
              - GENERIC_ACTION_98
              - GENERIC_ACTION_99
              - THEME_GENERIC_ACTION_1
              - THEME_GENERIC_ACTION_10
              - THEME_GENERIC_ACTION_11
              - THEME_GENERIC_ACTION_12
              - THEME_GENERIC_ACTION_13
              - THEME_GENERIC_ACTION_14
              - THEME_GENERIC_ACTION_15
              - THEME_GENERIC_ACTION_16
              - THEME_GENERIC_ACTION_17
              - THEME_GENERIC_ACTION_18
              - THEME_GENERIC_ACTION_19
              - THEME_GENERIC_ACTION_2
              - THEME_GENERIC_ACTION_20
              - THEME_GENERIC_ACTION_21
              - THEME_GENERIC_ACTION_22
              - THEME_GENERIC_ACTION_23
              - THEME_GENERIC_ACTION_24
              - THEME_GENERIC_ACTION_25
              - THEME_GENERIC_ACTION_26
              - THEME_GENERIC_ACTION_27
              - THEME_GENERIC_ACTION_28
              - THEME_GENERIC_ACTION_29
              - THEME_GENERIC_ACTION_3
              - THEME_GENERIC_ACTION_30
              - THEME_GENERIC_ACTION_4
              - THEME_GENERIC_ACTION_5
              - THEME_GENERIC_ACTION_6
              - THEME_GENERIC_ACTION_7
              - THEME_GENERIC_ACTION_8
              - THEME_GENERIC_ACTION_9
            type: string
          type: array
          uniqueItems: true
        enabled:
          type: boolean
        id:
          readOnly: true
          type: string
        properties:
          additionalProperties:
            items:
              type: string
            type: array
          type: object
        rule_type:
          enum:
            - BAD_COUNTRY
            - BLACKLIST_DOMAIN
            - BLACKLIST_REFERER_HEADER
            - BLOCKED
            - BOT_FILTER
            - EVENT_SPEED
            - EXISTING_CUSTOMER
            - FRIENDS_OF_ADVOCATE_CLICK_LIMIT
            - FRIENDS_OF_ADVOCATE_CONVERSION_LIMIT
            - FRIENDS_OF_ADVOCATE_REGISTRATION_LIMIT
            - GENERIC
            - GLOBAL_BLOCK
            - IP_FILTER
            - PERSON_DATA
            - PREVIEW
            - PROFILE_DISPLACED
            - RECENT_CUSTOMER
            - RECIPIENT_LIMIT
            - REFERRAL_AGE
            - REFERRAL_CAP
            - SAME_IP
            - SELF_REFERRAL
            - SHARE_COUNT_LIMIT
            - SIMILAR_FRIEND_ADVOCATE_EMAIL
            - SPAM_MESSAGE
            - VALID_EMAIL
          type: string
      required:
        - action_types
        - enabled
        - id
        - properties
        - rule_type
      type: object
    RewardRuleResponse:
      properties:
        count_rewards_based_on_partner_user_id:
          nullable: true
          type: boolean
        data_attribute_matcher_type:
          enum:
            - EXACT
            - REGEX
          nullable: true
          type: string
        data_attribute_name:
          nullable: true
          type: string
        data_attribute_value:
          nullable: true
          type: string
        expression:
          $ref: '#/components/schemas/RewardRuleExpression'
        id:
          readOnly: true
          type: string
        is_email_required:
          type: boolean
        is_referral_loop_allowed:
          type: boolean
        is_unique_friend_required:
          type: boolean
        min_cart_value:
          type: number
        referrals_per_reward:
          format: int32
          type: integer
        reward_count_limit:
          format: int32
          type: integer
        reward_count_since_days:
          format: int32
          nullable: true
          type: integer
        reward_count_since_month:
          format: int32
          nullable: true
          type: integer
        reward_every_x_friend_actions:
          format: int32
          nullable: true
          type: integer
        reward_slots:
          items:
            type: string
          type: array
          uniqueItems: true
        reward_supplier_id:
          type: string
        reward_value_limit:
          type: number
        reward_value_since_days:
          format: int32
          nullable: true
          type: integer
        reward_value_since_month:
          format: int32
          nullable: true
          type: integer
        rewardee:
          enum:
            - ADVOCATE
            - FRIEND
          type: string
        trigger_action_type:
          enum:
            - ANY_CLICK
            - ANY_PROMOTION
            - ANY_PURCHASE
            - ANY_REGISTER
            - ANY_SHARE
            - ANY_SHARE_REWARD
            - GENERIC_ACTION_1
            - GENERIC_ACTION_10
            - GENERIC_ACTION_100
            - GENERIC_ACTION_101
            - GENERIC_ACTION_102
            - GENERIC_ACTION_103
            - GENERIC_ACTION_104
            - GENERIC_ACTION_105
            - GENERIC_ACTION_106
            - GENERIC_ACTION_107
            - GENERIC_ACTION_108
            - GENERIC_ACTION_109
            - GENERIC_ACTION_11
            - GENERIC_ACTION_110
            - GENERIC_ACTION_111
            - GENERIC_ACTION_112
            - GENERIC_ACTION_113
            - GENERIC_ACTION_114
            - GENERIC_ACTION_115
            - GENERIC_ACTION_116
            - GENERIC_ACTION_117
            - GENERIC_ACTION_118
            - GENERIC_ACTION_119
            - GENERIC_ACTION_12
            - GENERIC_ACTION_120
            - GENERIC_ACTION_121
            - GENERIC_ACTION_122
            - GENERIC_ACTION_123
            - GENERIC_ACTION_124
            - GENERIC_ACTION_125
            - GENERIC_ACTION_126
            - GENERIC_ACTION_127
            - GENERIC_ACTION_128
            - GENERIC_ACTION_129
            - GENERIC_ACTION_13
            - GENERIC_ACTION_130
            - GENERIC_ACTION_131
            - GENERIC_ACTION_132
            - GENERIC_ACTION_133
            - GENERIC_ACTION_134
            - GENERIC_ACTION_135
            - GENERIC_ACTION_136
            - GENERIC_ACTION_137
            - GENERIC_ACTION_138
            - GENERIC_ACTION_139
            - GENERIC_ACTION_14
            - GENERIC_ACTION_140
            - GENERIC_ACTION_141
            - GENERIC_ACTION_142
            - GENERIC_ACTION_143
            - GENERIC_ACTION_144
            - GENERIC_ACTION_145
            - GENERIC_ACTION_146
            - GENERIC_ACTION_147
            - GENERIC_ACTION_148
            - GENERIC_ACTION_149
            - GENERIC_ACTION_15
            - GENERIC_ACTION_150
            - GENERIC_ACTION_151
            - GENERIC_ACTION_152
            - GENERIC_ACTION_153
            - GENERIC_ACTION_154
            - GENERIC_ACTION_155
            - GENERIC_ACTION_156
            - GENERIC_ACTION_157
            - GENERIC_ACTION_158
            - GENERIC_ACTION_159
            - GENERIC_ACTION_16
            - GENERIC_ACTION_160
            - GENERIC_ACTION_161
            - GENERIC_ACTION_162
            - GENERIC_ACTION_163
            - GENERIC_ACTION_164
            - GENERIC_ACTION_165
            - GENERIC_ACTION_166
            - GENERIC_ACTION_167
            - GENERIC_ACTION_168
            - GENERIC_ACTION_169
            - GENERIC_ACTION_17
            - GENERIC_ACTION_170
            - GENERIC_ACTION_171
            - GENERIC_ACTION_172
            - GENERIC_ACTION_173
            - GENERIC_ACTION_174
            - GENERIC_ACTION_175
            - GENERIC_ACTION_176
            - GENERIC_ACTION_177
            - GENERIC_ACTION_178
            - GENERIC_ACTION_179
            - GENERIC_ACTION_18
            - GENERIC_ACTION_180
            - GENERIC_ACTION_181
            - GENERIC_ACTION_182
            - GENERIC_ACTION_183
            - GENERIC_ACTION_184
            - GENERIC_ACTION_185
            - GENERIC_ACTION_186
            - GENERIC_ACTION_187
            - GENERIC_ACTION_188
            - GENERIC_ACTION_189
            - GENERIC_ACTION_19
            - GENERIC_ACTION_190
            - GENERIC_ACTION_191
            - GENERIC_ACTION_192
            - GENERIC_ACTION_193
            - GENERIC_ACTION_194
            - GENERIC_ACTION_195
            - GENERIC_ACTION_196
            - GENERIC_ACTION_197
            - GENERIC_ACTION_198
            - GENERIC_ACTION_199
            - GENERIC_ACTION_2
            - GENERIC_ACTION_20
            - GENERIC_ACTION_200
            - GENERIC_ACTION_21
            - GENERIC_ACTION_22
            - GENERIC_ACTION_23
            - GENERIC_ACTION_24
            - GENERIC_ACTION_25
            - GENERIC_ACTION_26
            - GENERIC_ACTION_27
            - GENERIC_ACTION_28
            - GENERIC_ACTION_29
            - GENERIC_ACTION_3
            - GENERIC_ACTION_30
            - GENERIC_ACTION_31
            - GENERIC_ACTION_32
            - GENERIC_ACTION_33
            - GENERIC_ACTION_34
            - GENERIC_ACTION_35
            - GENERIC_ACTION_36
            - GENERIC_ACTION_37
            - GENERIC_ACTION_38
            - GENERIC_ACTION_39
            - GENERIC_ACTION_4
            - GENERIC_ACTION_40
            - GENERIC_ACTION_41
            - GENERIC_ACTION_42
            - GENERIC_ACTION_43
            - GENERIC_ACTION_44
            - GENERIC_ACTION_45
            - GENERIC_ACTION_46
            - GENERIC_ACTION_47
            - GENERIC_ACTION_48
            - GENERIC_ACTION_49
            - GENERIC_ACTION_5
            - GENERIC_ACTION_50
            - GENERIC_ACTION_51
            - GENERIC_ACTION_52
            - GENERIC_ACTION_53
            - GENERIC_ACTION_54
            - GENERIC_ACTION_55
            - GENERIC_ACTION_56
            - GENERIC_ACTION_57
            - GENERIC_ACTION_58
            - GENERIC_ACTION_59
            - GENERIC_ACTION_6
            - GENERIC_ACTION_60
            - GENERIC_ACTION_61
            - GENERIC_ACTION_62
            - GENERIC_ACTION_63
            - GENERIC_ACTION_64
            - GENERIC_ACTION_65
            - GENERIC_ACTION_66
            - GENERIC_ACTION_67
            - GENERIC_ACTION_68
            - GENERIC_ACTION_69
            - GENERIC_ACTION_7
            - GENERIC_ACTION_70
            - GENERIC_ACTION_71
            - GENERIC_ACTION_72
            - GENERIC_ACTION_73
            - GENERIC_ACTION_74
            - GENERIC_ACTION_75
            - GENERIC_ACTION_76
            - GENERIC_ACTION_77
            - GENERIC_ACTION_78
            - GENERIC_ACTION_79
            - GENERIC_ACTION_8
            - GENERIC_ACTION_80
            - GENERIC_ACTION_81
            - GENERIC_ACTION_82
            - GENERIC_ACTION_83
            - GENERIC_ACTION_84
            - GENERIC_ACTION_85
            - GENERIC_ACTION_86
            - GENERIC_ACTION_87
            - GENERIC_ACTION_88
            - GENERIC_ACTION_89
            - GENERIC_ACTION_9
            - GENERIC_ACTION_90
            - GENERIC_ACTION_91
            - GENERIC_ACTION_92
            - GENERIC_ACTION_93
            - GENERIC_ACTION_94
            - GENERIC_ACTION_95
            - GENERIC_ACTION_96
            - GENERIC_ACTION_97
            - GENERIC_ACTION_98
            - GENERIC_ACTION_99
            - THEME_GENERIC_ACTION_1
            - THEME_GENERIC_ACTION_10
            - THEME_GENERIC_ACTION_11
            - THEME_GENERIC_ACTION_12
            - THEME_GENERIC_ACTION_13
            - THEME_GENERIC_ACTION_14
            - THEME_GENERIC_ACTION_15
            - THEME_GENERIC_ACTION_16
            - THEME_GENERIC_ACTION_17
            - THEME_GENERIC_ACTION_18
            - THEME_GENERIC_ACTION_19
            - THEME_GENERIC_ACTION_2
            - THEME_GENERIC_ACTION_20
            - THEME_GENERIC_ACTION_21
            - THEME_GENERIC_ACTION_22
            - THEME_GENERIC_ACTION_23
            - THEME_GENERIC_ACTION_24
            - THEME_GENERIC_ACTION_25
            - THEME_GENERIC_ACTION_26
            - THEME_GENERIC_ACTION_27
            - THEME_GENERIC_ACTION_28
            - THEME_GENERIC_ACTION_29
            - THEME_GENERIC_ACTION_3
            - THEME_GENERIC_ACTION_30
            - THEME_GENERIC_ACTION_4
            - THEME_GENERIC_ACTION_5
            - THEME_GENERIC_ACTION_6
            - THEME_GENERIC_ACTION_7
            - THEME_GENERIC_ACTION_8
            - THEME_GENERIC_ACTION_9
          type: string
      required:
        - count_rewards_based_on_partner_user_id
        - data_attribute_matcher_type
        - data_attribute_name
        - data_attribute_value
        - expression
        - id
        - is_email_required
        - is_referral_loop_allowed
        - is_unique_friend_required
        - min_cart_value
        - referrals_per_reward
        - reward_count_limit
        - reward_count_since_days
        - reward_count_since_month
        - reward_every_x_friend_actions
        - reward_slots
        - reward_supplier_id
        - reward_value_limit
        - reward_value_since_days
        - reward_value_since_month
        - rewardee
        - trigger_action_type
      type: object
    TransitionRuleResponse:
      properties:
        action_type:
          enum:
            - ANY_CLICK
            - ANY_PROMOTION
            - ANY_PURCHASE
            - ANY_REGISTER
            - ANY_SHARE
            - ANY_SHARE_REWARD
            - GENERIC_ACTION_1
            - GENERIC_ACTION_10
            - GENERIC_ACTION_100
            - GENERIC_ACTION_101
            - GENERIC_ACTION_102
            - GENERIC_ACTION_103
            - GENERIC_ACTION_104
            - GENERIC_ACTION_105
            - GENERIC_ACTION_106
            - GENERIC_ACTION_107
            - GENERIC_ACTION_108
            - GENERIC_ACTION_109
            - GENERIC_ACTION_11
            - GENERIC_ACTION_110
            - GENERIC_ACTION_111
            - GENERIC_ACTION_112
            - GENERIC_ACTION_113
            - GENERIC_ACTION_114
            - GENERIC_ACTION_115
            - GENERIC_ACTION_116
            - GENERIC_ACTION_117
            - GENERIC_ACTION_118
            - GENERIC_ACTION_119
            - GENERIC_ACTION_12
            - GENERIC_ACTION_120
            - GENERIC_ACTION_121
            - GENERIC_ACTION_122
            - GENERIC_ACTION_123
            - GENERIC_ACTION_124
            - GENERIC_ACTION_125
            - GENERIC_ACTION_126
            - GENERIC_ACTION_127
            - GENERIC_ACTION_128
            - GENERIC_ACTION_129
            - GENERIC_ACTION_13
            - GENERIC_ACTION_130
            - GENERIC_ACTION_131
            - GENERIC_ACTION_132
            - GENERIC_ACTION_133
            - GENERIC_ACTION_134
            - GENERIC_ACTION_135
            - GENERIC_ACTION_136
            - GENERIC_ACTION_137
            - GENERIC_ACTION_138
            - GENERIC_ACTION_139
            - GENERIC_ACTION_14
            - GENERIC_ACTION_140
            - GENERIC_ACTION_141
            - GENERIC_ACTION_142
            - GENERIC_ACTION_143
            - GENERIC_ACTION_144
            - GENERIC_ACTION_145
            - GENERIC_ACTION_146
            - GENERIC_ACTION_147
            - GENERIC_ACTION_148
            - GENERIC_ACTION_149
            - GENERIC_ACTION_15
            - GENERIC_ACTION_150
            - GENERIC_ACTION_151
            - GENERIC_ACTION_152
            - GENERIC_ACTION_153
            - GENERIC_ACTION_154
            - GENERIC_ACTION_155
            - GENERIC_ACTION_156
            - GENERIC_ACTION_157
            - GENERIC_ACTION_158
            - GENERIC_ACTION_159
            - GENERIC_ACTION_16
            - GENERIC_ACTION_160
            - GENERIC_ACTION_161
            - GENERIC_ACTION_162
            - GENERIC_ACTION_163
            - GENERIC_ACTION_164
            - GENERIC_ACTION_165
            - GENERIC_ACTION_166
            - GENERIC_ACTION_167
            - GENERIC_ACTION_168
            - GENERIC_ACTION_169
            - GENERIC_ACTION_17
            - GENERIC_ACTION_170
            - GENERIC_ACTION_171
            - GENERIC_ACTION_172
            - GENERIC_ACTION_173
            - GENERIC_ACTION_174
            - GENERIC_ACTION_175
            - GENERIC_ACTION_176
            - GENERIC_ACTION_177
            - GENERIC_ACTION_178
            - GENERIC_ACTION_179
            - GENERIC_ACTION_18
            - GENERIC_ACTION_180
            - GENERIC_ACTION_181
            - GENERIC_ACTION_182
            - GENERIC_ACTION_183
            - GENERIC_ACTION_184
            - GENERIC_ACTION_185
            - GENERIC_ACTION_186
            - GENERIC_ACTION_187
            - GENERIC_ACTION_188
            - GENERIC_ACTION_189
            - GENERIC_ACTION_19
            - GENERIC_ACTION_190
            - GENERIC_ACTION_191
            - GENERIC_ACTION_192
            - GENERIC_ACTION_193
            - GENERIC_ACTION_194
            - GENERIC_ACTION_195
            - GENERIC_ACTION_196
            - GENERIC_ACTION_197
            - GENERIC_ACTION_198
            - GENERIC_ACTION_199
            - GENERIC_ACTION_2
            - GENERIC_ACTION_20
            - GENERIC_ACTION_200
            - GENERIC_ACTION_21
            - GENERIC_ACTION_22
            - GENERIC_ACTION_23
            - GENERIC_ACTION_24
            - GENERIC_ACTION_25
            - GENERIC_ACTION_26
            - GENERIC_ACTION_27
            - GENERIC_ACTION_28
            - GENERIC_ACTION_29
            - GENERIC_ACTION_3
            - GENERIC_ACTION_30
            - GENERIC_ACTION_31
            - GENERIC_ACTION_32
            - GENERIC_ACTION_33
            - GENERIC_ACTION_34
            - GENERIC_ACTION_35
            - GENERIC_ACTION_36
            - GENERIC_ACTION_37
            - GENERIC_ACTION_38
            - GENERIC_ACTION_39
            - GENERIC_ACTION_4
            - GENERIC_ACTION_40
            - GENERIC_ACTION_41
            - GENERIC_ACTION_42
            - GENERIC_ACTION_43
            - GENERIC_ACTION_44
            - GENERIC_ACTION_45
            - GENERIC_ACTION_46
            - GENERIC_ACTION_47
            - GENERIC_ACTION_48
            - GENERIC_ACTION_49
            - GENERIC_ACTION_5
            - GENERIC_ACTION_50
            - GENERIC_ACTION_51
            - GENERIC_ACTION_52
            - GENERIC_ACTION_53
            - GENERIC_ACTION_54
            - GENERIC_ACTION_55
            - GENERIC_ACTION_56
            - GENERIC_ACTION_57
            - GENERIC_ACTION_58
            - GENERIC_ACTION_59
            - GENERIC_ACTION_6
            - GENERIC_ACTION_60
            - GENERIC_ACTION_61
            - GENERIC_ACTION_62
            - GENERIC_ACTION_63
            - GENERIC_ACTION_64
            - GENERIC_ACTION_65
            - GENERIC_ACTION_66
            - GENERIC_ACTION_67
            - GENERIC_ACTION_68
            - GENERIC_ACTION_69
            - GENERIC_ACTION_7
            - GENERIC_ACTION_70
            - GENERIC_ACTION_71
            - GENERIC_ACTION_72
            - GENERIC_ACTION_73
            - GENERIC_ACTION_74
            - GENERIC_ACTION_75
            - GENERIC_ACTION_76
            - GENERIC_ACTION_77
            - GENERIC_ACTION_78
            - GENERIC_ACTION_79
            - GENERIC_ACTION_8
            - GENERIC_ACTION_80
            - GENERIC_ACTION_81
            - GENERIC_ACTION_82
            - GENERIC_ACTION_83
            - GENERIC_ACTION_84
            - GENERIC_ACTION_85
            - GENERIC_ACTION_86
            - GENERIC_ACTION_87
            - GENERIC_ACTION_88
            - GENERIC_ACTION_89
            - GENERIC_ACTION_9
            - GENERIC_ACTION_90
            - GENERIC_ACTION_91
            - GENERIC_ACTION_92
            - GENERIC_ACTION_93
            - GENERIC_ACTION_94
            - GENERIC_ACTION_95
            - GENERIC_ACTION_96
            - GENERIC_ACTION_97
            - GENERIC_ACTION_98
            - GENERIC_ACTION_99
            - THEME_GENERIC_ACTION_1
            - THEME_GENERIC_ACTION_10
            - THEME_GENERIC_ACTION_11
            - THEME_GENERIC_ACTION_12
            - THEME_GENERIC_ACTION_13
            - THEME_GENERIC_ACTION_14
            - THEME_GENERIC_ACTION_15
            - THEME_GENERIC_ACTION_16
            - THEME_GENERIC_ACTION_17
            - THEME_GENERIC_ACTION_18
            - THEME_GENERIC_ACTION_19
            - THEME_GENERIC_ACTION_2
            - THEME_GENERIC_ACTION_20
            - THEME_GENERIC_ACTION_21
            - THEME_GENERIC_ACTION_22
            - THEME_GENERIC_ACTION_23
            - THEME_GENERIC_ACTION_24
            - THEME_GENERIC_ACTION_25
            - THEME_GENERIC_ACTION_26
            - THEME_GENERIC_ACTION_27
            - THEME_GENERIC_ACTION_28
            - THEME_GENERIC_ACTION_29
            - THEME_GENERIC_ACTION_3
            - THEME_GENERIC_ACTION_30
            - THEME_GENERIC_ACTION_4
            - THEME_GENERIC_ACTION_5
            - THEME_GENERIC_ACTION_6
            - THEME_GENERIC_ACTION_7
            - THEME_GENERIC_ACTION_8
            - THEME_GENERIC_ACTION_9
          type: string
        approve_high_quality:
          type: boolean
        approve_low_quality:
          type: boolean
        transition_period_milliseconds:
          format: int64
          type: integer
        transition_rule_id:
          type: string
      required:
        - action_type
        - approve_high_quality
        - approve_low_quality
        - transition_period_milliseconds
        - transition_rule_id
      type: object
    CampaignControllerResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignStepResponseBase'
        - properties:
            actions:
              items:
                $ref: '#/components/schemas/CampaignControllerActionResponse'
              type: array
            aliases:
              $ref: '#/components/schemas/AliasesInCampaignControllerResponse'
            controller_id:
              type: string
            enabled_on_states:
              $ref: '#/components/schemas/EnabledOnStatesInCampaignControllerResponse'
            id:
              readOnly: true
              type: string
            journey_names:
              $ref: '#/components/schemas/JourneyNamesInCampaignControllerResponse'
            name:
              $ref: '#/components/schemas/NameInCampaignControllerResponse'
            scope:
              $ref: '#/components/schemas/ScopeInCampaignControllerResponse'
            selectors:
              $ref: '#/components/schemas/SelectorsInCampaignControllerResponse'
            send_policy:
              $ref: '#/components/schemas/SendPolicyInCampaignControllerResponse'
            type:
              enum:
                - CONTROLLER
              type: string
          type: object
      description: >-
        Stored campaign controller definition. Fields `enabled`, `name`,
        `scope`, `enabled_on_states`, `selectors`, `aliases`, `journey_names`,
        `send_policy`, and `step_builder` are unevaluated and appear in
        buildtime-evaluatable form.
      required:
        - actions
        - aliases
        - component_ids
        - component_references
        - controller_id
        - created_date
        - data
        - enabled
        - enabled_on_states
        - id
        - journey_names
        - name
        - scope
        - selectors
        - send_policy
        - step_builder
        - triggers
        - type
        - updated_date
      type: object
      title: CONTROLLER
    CampaignFrontendControllerResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignStepResponseBase'
        - properties:
            actions:
              items:
                $ref: '#/components/schemas/CampaignControllerActionResponse'
              type: array
            aliases:
              $ref: '#/components/schemas/AliasesInCampaignFrontendControllerResponse'
            category:
              $ref: >-
                #/components/schemas/CategoryInCampaignFrontendControllerResponse
            enabled_on_states:
              $ref: >-
                #/components/schemas/EnabledOnStatesInCampaignFrontendControllerResponse
            id:
              readOnly: true
              type: string
            journey_names:
              $ref: >-
                #/components/schemas/JourneyNamesInCampaignFrontendControllerResponse
            name:
              $ref: '#/components/schemas/NameInCampaignFrontendControllerResponse'
            scope:
              $ref: '#/components/schemas/ScopeInCampaignFrontendControllerResponse'
            send_policy:
              $ref: >-
                #/components/schemas/SendPolicyInCampaignFrontendControllerResponse
            type:
              enum:
                - FRONTEND_CONTROLLER
              type: string
          type: object
      description: >-
        Stored campaign frontend controller definition. Fields `enabled`,
        `name`, `scope`, `enabled_on_states`, `category`, `aliases`,
        `journey_names`, `send_policy`, and `step_builder` are unevaluated and
        appear in buildtime-evaluatable form.
      required:
        - actions
        - aliases
        - category
        - component_ids
        - component_references
        - created_date
        - data
        - enabled
        - enabled_on_states
        - id
        - journey_names
        - name
        - scope
        - send_policy
        - step_builder
        - triggers
        - type
        - updated_date
      type: object
      title: FRONTEND_CONTROLLER
    CampaignJourneyEntryResponse:
      allOf:
        - $ref: '#/components/schemas/CampaignStepResponseBase'
        - properties:
            id:
              readOnly: true
              type: string
            journey_name:
              $ref: '#/components/schemas/JourneyNameInCampaignJourneyEntryResponse'
            key:
              $ref: '#/components/schemas/JourneyKeyResponse'
            priority:
              $ref: '#/components/schemas/PriorityInCampaignJourneyEntryResponse'
            type:
              enum:
                - JOURNEY_ENTRY
              type: string
          type: object
      description: >-
        Stored campaign journey entry definition. Fields `enabled`,
[...]
